;Copyright 2017 Daniel Green, v1.0 modified 06/13/17 8:15am

;Binal is free for both business and personal use. It can be freely modified and redistributed providing that:
;1. all notices remain intact.
;2. you acknowledge where it originally came from.
;3. it is only used for legal and ethical purposes.
;4. no profit is derived from its distribution.

#noenv
#singleinstance, ignore
setbatchlines, -1
setworkingdir, %a_scriptdir%

onmessage(0x0201, "_drag")
onmessage(0x11, "_on_shutdown")

menu, tray, nostandard
menu, tray, tip, Binal - Binary Clock
menu, tray, add, Settings, settings_show
menu, tray, icon, settings, %a_scriptname%, 2, 0
menu, tray, add, About, about
menu, tray, icon, about, %a_scriptname%, 3, 0
menu, tray, add
menu, tray, add, Exit, exit
menu, tray, icon, exit, %a_scriptname%, 4, 0

menu, context, add, Settings, settings_show
menu, context, icon, settings, %a_scriptname%, 2, 0
menu, context, add, About, about
menu, context, icon, about, %a_scriptname%, 3, 0
menu, context, add
menu, context, add, Exit, exit
menu, context, icon, exit, %a_scriptname%, 4, 0

gosub, get_settings
gosub, osd_create
gosub, settings_gui_create
settimer, check, 100

gui, 1:show, w145 h90 x%x% y%y% na, Binal OSD
winset, bottom
gosub, bounds
return

osd_create:
 {
   gui, 1:-caption +toolwindow +lastfound

   gui, 1:font, s8 w600, Arial Bold
   
   gui, 1:add, progress, x14 y10 w2 h50 disabled vpm
   if (mode = 0)
    {
      guicontrol, 1:hide, pm
    }
   
   gui, 1:add, progress, x10 y70 w10 h10 disabled vh1_1
   gui, 1:add, progress, x10 y50 w10 h10 disabled vh1_2
   if (mode = 1)
    {
      guicontrol, 1:hide, h1_2
    }

   gui, 1:add, progress, x30 y70 w10 h10 disabled vh2_1
   gui, 1:add, progress, x30 y50 w10 h10 disabled vh2_2
   gui, 1:add, progress, x30 y30 w10 h10 disabled vh2_3
   gui, 1:add, progress, x30 y10 w10 h10 disabled vh2_4

   gui, 1:add, progress, x50 y70 w10 h10 disabled vm1_1
   gui, 1:add, progress, x50 y50 w10 h10 disabled vm1_2
   gui, 1:add, progress, x50 y30 w10 h10 disabled vm1_3

   gui, 1:add, progress, x70 y70 w10 h10 disabled vm2_1
   gui, 1:add, progress, x70 y50 w10 h10 disabled vm2_2
   gui, 1:add, progress, x70 y30 w10 h10 disabled vm2_3
   gui, 1:add, progress, x70 y10 w10 h10 disabled vm2_4

   gui, 1:add, progress, x90 y70 w10 h10 disabled vs1_1
   gui, 1:add, progress, x90 y50 w10 h10 disabled vs1_2
   gui, 1:add, progress, x90 y30 w10 h10 disabled vs1_3

   gui, 1:add, progress, x110 y70 w10 h10 disabled vs2_1
   gui, 1:add, progress, x110 y50 w10 h10 disabled vs2_2
   gui, 1:add, progress, x110 y30 w10 h10 disabled vs2_3
   gui, 1:add, progress, x110 y10 w10 h10 disabled vs2_4
   
   gui, 1:add, text, x130 y68 w10 h12 c%text% vtxt1, 1
   gui, 1:add, text, x130 y48 w10 h12 c%text% vtxt2, 2
   gui, 1:add, text, x130 y28 w10 h12 c%text% vtxt3, 4
   gui, 1:add, text, x130 y8 w10 h12 c%text% vtxt4, 8
   
   gui, 1:color, %window%
 }
return

check:
 {
   if (last != a_sec)
    {
      last := a_sec
      gosub, update
    }
 }
return

update:
 {
   num := _bin(_time("second", 2))
   count := 4
   loop, 4
    {
      state := substr(num, count--, 1) ? on : off
      guicontrol, 1:+background%state%, s2_%a_index%
    }
   
   num := _bin(_time("second", 1))
   count := 4
   loop, 3
    {
      state := substr(num, count--, 1) ? on : off
      guicontrol, 1:+background%state%, s1_%a_index%
    }
   
   num := _bin(_time("minute", 2))
   count := 4
   loop, 4
    {
      state := substr(num, count--, 1) ? on : off
      guicontrol, 1:+background%state%, m2_%a_index%
    }
   
   num := _bin(_time("minute", 1))
   count := 4
   loop, 3
    {
      state := substr(num, count--, 1) ? on : off
      guicontrol, 1:+background%state%, m1_%a_index%
    }
   
   num := _bin(_time("hour", 2))
   count := 4
   loop, 4
    {
      state := substr(num, count--, 1) ? on : off
      guicontrol, 1:+background%state%, h2_%a_index%
    }
   
   num := _bin(_time("hour", 1))
   count := 4
   loop, % mode ? 1 : 2
    {
      state := substr(num, count--, 1) ? on : off
      guicontrol, 1:+background%state%, h1_%a_index%
    }
   
   if (mode)
    {
      state := a_hour > 11 ? on : off
      guicontrol, 1:+background%state%, pm
    }
 }
return

_time(fragment, place)
 {
   global mode
   
   if (fragment = "second")
    {
      formattime, time, , ss
    }
   else if (fragment = "minute")
    {
      formattime, time, , mm
    }
   else if (fragment = "hour")
    {
      formattime, time, , % mode ? "hh" : "HH"
    }

   return substr(time, place, 1)
 }

_bin(input)
 {
   loop 4
    {
      out .= (input >> (4 - a_index) & 1)
    }
   return out
 }

_drag()
 {
   if (a_gui = 1)
    {
      postmessage, 0xa1, 2
      winset, bottom
      keywait, lbutton
      gosub, bounds
    }
   return
 }

guicontextmenu:
 {
   menu, context, show
 }
return

bounds:
 {
   wingetpos, x, y, , , Binal OSD
   h_offset := _percent(_percent(a_screendpi, 96, 1), 145, 0)
   v_offset := _percent(_percent(a_screendpi, 96, 1), 90, 0)

   sysget, var_, monitorworkarea

   if (x > (var_right - h_offset))
    {
      winmove, Binal OSD, , % (var_right - h_offset)
    }
   else if (x < 0)
    {
      winmove, Binal OSD, , 0
    }
   
   if (y > (var_bottom - v_offset))
    {
      winmove, Binal OSD, , , % (var_bottom - v_offset)
    }
   else if (y < 0)
    {
      winmove, Binal OSD, , , 0
    }
 }
return

_percent(input, base, mode)
 {
   return floor(mode ? (input / base) * 100 : base * (input / 100))
 }

settings_gui_create:
 {
   gui, 2:font, s8
   
   gui, 2:add, button, default x120 y135 w100 h22 gsave, Save
   gui, 2:add, button, x120 y158 w100 h22 g2guiclose, Cancel
   
   gui, 2:add, groupbox, x10 y10 w100 h50, On color:
   gui, 2:add, progress, x80 y30 w20 h20 disabled von_color_box

   gui, 2:add, groupbox, x120 y10 w100 h50 , Off color:
   gui, 2:add, progress, x190 y30 w20 h20 disabled voff_color_box

   gui, 2:add, groupbox, x10 y70 w100 h50, Text color:
   gui, 2:add, progress, x80 y90 w20 h20 disabled vtext_color_box

   gui, 2:add, groupbox, x120 y70 w100 h50, Base color:
   gui, 2:add, progress, x190 y90 w20 h20 disabled vbase_color_box

   gui, 2:add, groupbox, x10 y130 w100 h50, Mode:
   gui, 2:add, checkbox, x20 y150 w80 h20 vmode, 12 Hour
   
   gui, 2:font, s8, Lucida Console
   gui, 2:add, edit, limit6 x20 y30 w50 h20 von_color gshow_color
   gui, 2:add, edit, limit6 x130 y30 w50 h20 voff_color gshow_color
   gui, 2:add, edit, limit6 x20 y90 w50 h20 vtext_color gshow_color
   gui, 2:add, edit, limit6 x130 y90 w50 h20 vbase_color gshow_color
 }
return

show_color:
 {
   guicontrolget, gui_color, , %a_guicontrol%
   guicontrol, 2:+background%gui_color%, %a_guicontrol%_box
 }
return

get_settings:
 {
   iniread, mode, settings.ini, settings, mode, 0
   mode := (mode = "" ? 0 : mode)
   iniread, position, settings.ini, settings, position, default
   position := (position = "" ? "default" : position)
   iniread, on, settings.ini, settings, on, 3399FF
   on := (on = "" ? "3399FF" : on)
   iniread, off, settings.ini, settings, off, DDDDDD
   off := (off = "" ? "DDDDDD" : off)
   iniread, window, settings.ini, settings, window, FFFFFF
   window := (window = "" ? "FFFFFF" : window)
   iniread, text, settings.ini, settings, text, BBBBBB
   text := (text = "" ? "BBBBBB" : text)
   
   if (position = "default")
    {
      h_offset := _percent(_percent(a_screendpi, 96, 1), 145, 0)
      v_offset := _percent(_percent(a_screendpi, 96, 1), 90, 0)

      sysget, var_, monitorworkarea
      x := var_right - (h_offset + 10)
      y := var_bottom - (v_offset + 10)
    }
   else
    {
      stringsplit, pos, position, |
      x := pos1
      y := pos2
    }
 }
return

load_settings:
 {
   guicontrol, 2:, on_color, %on%
   guicontrol, 2:, off_color, %off%
   guicontrol, 2:, text_color, %text%
   guicontrol, 2:, base_color, %window%
   guicontrol, 2:, mode, %mode%
 }
return

settings_show:
 {
   gosub, load_settings
   gui, 2:show, w230 h190, Settings
 }
return

save:
 {
   gui, 2:submit
   
   stringupper, on_color, on_color
   stringupper, off_color, off_color
   stringupper, text_color, text_color
   stringupper, base_color, base_color

   if regexmatch(on_color . off_color . text_color . base_color, "[^0-9A-F]")
    {
      msgbox, 48, Error..., One or more of the color fields contains unsupported characters.`nHex colors may only consist of 0-9 a-f A-F., 10
      return
    }
   else if strlen(on_color . off_color . text_color . base_color) != 24
    {
      msgbox, 48, Error..., One or more of the color fields are incomplete.`nHex colors must consist of 6 characters., 10
      return
    }

   on := on_color
   off := off_color
   text := text_color
   window := base_color

   gosub, update

   gui, 1:color, %window%
   guicontrol, 1:+c%text%, txt1
   guicontrol, 1:+c%text%, txt2
   guicontrol, 1:+c%text%, txt3
   guicontrol, 1:+c%text%, txt4
   
   if (mode)
    {
      guicontrol, 1:hide, h1_2
      guicontrol, 1:show, pm
    }
   else
    {
      guicontrol, 1:show, h1_2
      guicontrol, 1:hide, pm
    }
   
   iniwrite, %on_color%, settings.ini, settings, on
   iniwrite, %off_color%, settings.ini, settings, off
   iniwrite, %text_color%, settings.ini, settings, text
   iniwrite, %base_color%, settings.ini, settings, window
   iniwrite, %mode%, settings.ini, settings, mode
 }
return

exit:
 {
   _on_shutdown()
 }
return

_on_shutdown()
 {
   wingetpos, x, y, , , Binal OSD
   iniwrite, %x%|%y%, settings.ini, settings, position
   exitapp
 }

about:
 {
   if (about_gui != 1)
    {
      gosub, get_about
      gui, 3:font, s8
      gui, 3:add, button, x340 y275 w60 h20 ghome_site, Home
      gui, 3:add, button, default x400 y275 w60 h20 g3guiclose, OK
      gui, 3:add, edit, +readonly vscroll x10 y10 w450 h260, %about%
      gui, 3:show, center w470 h300, About Binal
      about_gui := 1
    }
   else
    {
      gui, 3:destroy
      about_gui := 0
    }
 }
return

get_about:
 {
about := 
(
"Binal v1.0

Copyright 2017 Daniel Green

Binal is a customizable binary clock desktop widget.

Binal is free for both business and personal use. It can be freely modified and redistributed providing that:
   1. All notices remain intact.
   2. You acknowledge where it originally came from.
   3. It is only used for legal and ethical purposes.
   4. No profit is derived from its distribution.

Features:
   Displays a minimalist grid depicting the current time via binary on/off states.
   12 and 24 hour modes.
   Fully customizable color scheme for all display elements.
   Portable, can run from removable media and makes no changes to the host system.
   Open source, written in AutoHotkey (http://www.ahkscript.org).

Instructions:
   On first launch the OSD will appear in the lower right of the primary monitor. It can then be dragged to any desired position. That new position will be saved on program close.
   All interface colors and 12/24 hour mode can be set from the settings interface, accessible from the tray menu and by right click on clock face. These settings will be saved to settings.ini in the program directory.
   To restore default settings delete settings.ini and restart the application.
   
How to read:
   Binal displays the time in 6 varying height columns. Each column represents a single digit as it would appear on a standard clock display. To determine what number is shown in a column add the numeric values of all active dots in that column. Dot values are indicated by the numbers 1-8 along the right edge of the clock face. If there are no active dots in a column it is a 0 for that column. If the 1 and 8 positions are active it means a 9 for that column, and so on until you have a standard time of hours minutes and seconds.
   When in 12 hour mode there is a PM indicator in the form of a thin line in the upper left of the clock face. This line will be inactive for AM and active for PM.

Requirements:
   Windows XP +

History:
   v1.0
      Initial release.

Note:
   Binal is designed to work on single monitor systems. I have not, and can not test it on multiple monitors. Please be aware of this and the possible behavioral quirks this may cause if used with multiple monitors. Please report any issues you may find."
)
 }
return

home_site:
 {
   run, http://crzyinc.weebly.com/binal.html
 }
return

2guiclose:
 {
   gui, 2:cancel
 }
return

3guiclose:
 {
   gui, 3:destroy
   about_gui := 0
 }
return